# -*- coding: utf-8 -*-
"""
Created on Fri Mar 10 17:27:06 2017

@author: akibdpt
"""

#difference --> arithmatic difference (1.0-0.1 = 0.9)
#no weight form == zero weight form (0 is default)
#if the weight become 0 --> remove the weight but not its base (line/point)

from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import super
from builtins import str

from .individual import individual


class rWeight(individual):
            
    MIN = 0
    
    type = 'ind-rWeight'
    
    def __init__(self, sort = None, w = 0, *args, **kwargs):
        super(rWeight, self).__init__(sort)
        if sort.baseSort().arguments is not None and w > sort.baseSort().arguments.value:
            w = sort.baseSort().arguments.value
        self.value = w
            
    def printVal(self):
        return str(self.value)
        
    def length(self):
        return len(self.value)
        
    def isNil(self):
        return self.value == self.MIN
        
    def equals(self, other):
        return (self.value == other.value)
        
    def __ne__(self, other):
        return not self == other
        
    def compareValue(self, other):
        if self.value > other.value:
            return 1
        elif self.value == other.value:
            return 0
        return -1    
    
    def replicateInd(self):
        return rWeight(self.sort, self.value)

    def getMinInd(self):
        return rWeight(self.sort)
        
    def complement(self, other):
        if self.isNil():
            return False
        if other is None or other.isNil():
            return True
        self.value = self.value - other.value
        if self.value <= self.MIN:
            self.value = self.MIN
            return False
        return True

    @staticmethod
    def parse(reader, sort):
        neg = False
        if reader.token() == '-':
            reader.newToken()
            neg = True
        try:
            ind = rWeight(sort, int(reader.value()))
        except:
            ind = rWeight(sort, float(reader.value()))
        if neg:
            ind.value = -ind.value
        reader.newToken()
        return ind

