# -*- coding: utf-8 -*-
"""
Created on Wed Sep 21 09:08:57 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
"""
from future import standard_library
standard_library.install_aliases()
"""
from .mapping import mapping
from .paramSet import paramSet
from ..transform.transform import transform

class parametricMap(mapping):
    type = 'map-parametric'
    def __init__(self, *args, **kwargs):
        super(parametricMap, self).__init__()     
        self.paramsets = {}
        
    @staticmethod
    def getInstance():
        return parametricMap()
        
    def clear(self):
        self.paramsets = {}
    
    def map(self, fromInd, toInd):
        params = paramSet()
        if fromInd.map(params, toInd):
            if not params.isEmpty():
                key = fromInd.sort.name+"|"+str(fromInd)
                try:
                    array = self.paramsets[key]
                except KeyError:
                    array = []
                    self.paramsets[key] = array
                if params not in array:
                    array.append(params)
            return True
        return False
        #except:
            #print('~~~')
            #return False
        
    def potentialParamSets(self):
        result = []
        if len(self.paramsets) == 0:
            return result
        for string in self.paramsets:
            array = self.paramsets[string]
            if len(result) == 0:
                for i in array:
                    result.append(i)
            else:
                res = []
                
                for i in result:
                    for j in array:
                        pSet = paramSet()
                        pSet.merge(i)
                        pSet.merge(j)
                        res.append(pSet)
                result = res
        return result
        
    def potentialTransforms(self):
        return [transform()]