# -*- coding: utf-8 -*-
"""
Created on Fri Aug 12 14:33:20 2016

@author: akibdpt
"""
from __future__ import division
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import absolute_import
from __future__ import with_statement

from builtins import int
from builtins import str
"""
from future import standard_library
standard_library.install_aliases()
"""
from builtins import object
from math import sqrt, pi, sin, cos, tan, asin, acos, atan, atan2
from math import log10, floor
"""
 * Coordinate is the representational unit for geometric
 * Coordinate is saved and represented as symbolic mathematics
 * allowing the exact representation of real number
 * e.g. sin(2*pi/3) will be represented as sqrt(3)/2 
"""




class coordinate(object):
    
    p = 8
    defaultP = 8
    c0 = 0
    c1 = 1
    
    def __init__(self, num):
        if isinstance(num, coordinate):
            # raise ValueError('initiating an already existing coordinate object')
            self.value = num.value
        elif isinstance(num, int) or isinstance(num, float):
            self.value = num
        else:
            self.value = float(num)
            
    
    def __float__(self):
        #raise NotImplementedError
        return float(self.value)
        
    def __int__(self):
        return int(self.value)
        
    def __repr__(self):
        return str(self.value)
        return str(round(self.value,3))
        
    def __str__(self):
        return str(self.value)
        return str(round(self.value,self.p))
        
    @staticmethod
    def precision():
        return coordinate.p
        
    @staticmethod
    def setPrecision(prec = None):
        if prec is None:
            coordinate.p = coordinate.defaultP
        else:
            coordinate.p = prec
        
    @staticmethod
    def setDefaultPrecision():
        coordinate.p = coordinate.defaultP
        
    def __round__(self, n = None):
        if n is None:
            return coordinate(round(self.value))
        return coordinate(round(self.value,n))
                
        
    """
    finding the sign of the coordinate: 1 if positive, -1 if negative, 0 if 0
    """
    def sign(self):
        if self == 0:
            return 0
        if self > 0:
            return 1
        return -1
        
    """
    check if the coordinate is equal to 0
    """
    def isZero(self):
        if self.value == 0:
            return True
        return round(self.value, self.p) == 0
        
    """
    check if the coordinate is equal to 1
    """
    def isOne(self):
        if self.value == 0:
            return True
        return round(self.value, self.p) == 1
    
    """
    finding square root of the coordinate
    """
    def sqrt(self):
        return coordinate(sqrt(self.value))
        
    """
    addition
    """
    def __add__(self, other):
        if not isinstance(other, coordinate):
            other = coordinate(other)
        return coordinate(self.value + other.value)   

    """
    subtraction
    """
    def __sub__(self, other):
        if not isinstance(other, coordinate):
            other = coordinate(other)
        return coordinate(self.value - other.value)

    """
    multiplication
    """
    def __mul__(self, other):
        if not isinstance(other, coordinate):
            other = coordinate(other)
        return coordinate(self.value * other.value)

    """
    division
    """
    def __truediv__(self, other):
        if not isinstance(other, coordinate):
            other = coordinate(other)
        return coordinate(self.value / other.value)

    """
    floor dividsion (only taking the integer part of the result)
    e.g. 23 // 2 = 11
    """
    def __floordiv__(self, other):
        if not isinstance(other, coordinate):
            other = coordinate(other)
        return coordinate(self.value // other.value)  

    """
    power
    """
    def __pow__(self, other):
        if not isinstance(other, coordinate):
            other = coordinate(other)
            
        return coordinate(self.value ** other.value)

    """
    modular
    """
    def __mod__(self, other):
        if not isinstance(other, coordinate):
            other = coordinate(other)
        return coordinate(self.value % other.value)   
        
    """
    addition
    """
    def __radd__(self, other):
        other = coordinate(other)
        return coordinate(other.value + self.value)   

    """
    subtraction
    """
    def __rsub__(self, other):
        other = coordinate(other)
        return coordinate(other.value - self.value)

    """
    multiplication
    """
    def __rmul__(self, other):
        other = coordinate(other)
        return coordinate(other.value * self.value)

    """
    division
    """
    def __rtruediv__(self, other):
        other = coordinate(other)
        return coordinate(other.value / self.value)

    """
    floor dividsion (only taking the integer part of the result)
    e.g. 23 // 2 = 11
    """
    def __rfloordiv__(self, other):
        other = coordinate(other)
        return coordinate(other.value // self.value)  

    """
    power
    """
    def __rpow__(self, other):
        raise ValueError('POWER: this is not coordinate')
        other = coordinate(other)
        return coordinate(other.value ** self.value) 

    """
    modular
    """
    def __rmod__(self, other):
        other = coordinate(other)
        return coordinate(other.value % self.value)   

    """
    negation
    """
    def __neg__ (self):
        return coordinate(-self.value)   

    """
    """
    def __pos__ (self):
        return  coordinate(self.value)

    """
    absolute value
    """
    def __abs__(self):
        return coordinate(abs(self.value))

    """
    inverting
    """
    def invert (self):
        return coordinate(1 / self.value)   
        
    """
    def convertVal(self, other):
        thisVal = self.rounding(self.value)
        if isinstance(other, coordinate):
            otherVal = self.rounding(other.value)
        elif isinstance(other, int):
            otherVal = other
        elif isinstance(other, float):
            otherVal = self.rounding(other)
        elif isinstance(other, str):
            otherVal = self.rounding(float(other))
        else:
            raise ValueError('Unidentifiable number type: '+str(other.__class__))
        return thisVal, otherVal
    """
    def convertVal(self, other):
        thisVal = round(self.value, self.p)
        if isinstance(other, coordinate):
            otherVal = round(other.value, self.p)
        elif isinstance(other, int):
            otherVal = other
        elif isinstance(other, float):
            otherVal = round(other, self.p)
        elif isinstance(other, str):
            otherVal = round(float(other), self.p)
        else:
            raise ValueError('Unidentifiable number type: '+str(other.__class__))
        return thisVal, otherVal

    """
    check equality
    """    
    def __eq__(self, other):
        thisVal, otherVal = self.convertVal(other)
        return thisVal == otherVal
        
    def __ne__(self, other):
        return not self == other

    """
    <
    """
    def __lt__(self,other):
        thisVal, otherVal = self.convertVal(other)
        return thisVal < otherVal

    """
    >
    """
    
    def __gt__(self,other):
        thisVal, otherVal = self.convertVal(other)
        return thisVal > otherVal
        
    """
    <=
    """
    def __le__(self,other):
        thisVal, otherVal = self.convertVal(other)
        return thisVal <= otherVal

    """
    >=
    """
    def __ge__(self,other):
        thisVal, otherVal = self.convertVal(other)
        return thisVal >= otherVal
    """
    >>
    """
    def __rshift__(self, other):
        if isinstance(other, coordinate):
            return coordinate(int(self.value) >> int(other.value))
        return coordinate(int(self.value) >> int(other))
        

    """
    comparing values
    """
    def compareValue(self,other):
        thisVal, otherVal = self.convertVal(other)
        if thisVal == otherVal:
            return 0
        elif thisVal > otherVal:
            return 1
        return -1




c0 = coordinate(0)
c1 = coordinate(1)
c2 = coordinate(2)
cn1 = coordinate(-1)
c0p5 = coordinate('0.5')

def isint(num):
    if isinstance(num, coordinate) or isinstance(num, float):
        if int(num) == num:
            return True
    elif isinstance(num, int):
        return True
    return False